 /**
  * Title : OnlineTests
  * Author : Silvia Kopcheva
  * Description : Utilities class for OnlineTests project. 
  * Holds methods for converting strings from and to DataBase
  */
 package onlineTests;

/**
 * Utility class for OnlineTests project. 
 * Holds methods for converting strings from and to DataBase.
 * @author Silvia Kopcheva
 *
 * @see User 
 * @see LoadDataModel 
 * @see DBConnections
 */
public class Utils {

    /**
     * This method converts string, for insert it into DataBase
     * @param dataString text to be converted
     * @return converted text
     */
    public static String toDB(String dataString) {
        StringBuffer  resultStr = new StringBuffer();
        int           dataLength = dataString.length();
        short         workChar;
        
        for(int i = 0; i < dataLength; i++) {
          workChar = (short) dataString.charAt(i);
          if((workChar >= 192) && (workChar <= 255))
            resultStr.append((char) (workChar + 848));
          else if((workChar == 34)||(workChar == 92)) {
            resultStr.append('\\');
            resultStr.append((char) workChar);
          }
          else 
          resultStr.append((char) workChar);
        }
        return resultStr.toString();
    }

    /**
     * This method converts string, gotten from DataBase
     * @param dataString text to be converted
     * @return converted text
     */
    public static String fromDB(String dataString) {
        StringBuffer  resultStr = new StringBuffer();
        int           dataLength = dataString.length();
        short         workChar;
        boolean       wasSeparator = false;
        for(int i = 0; i < dataLength; i++) {
          workChar=(short) dataString.charAt(i);
          if((workChar >= 1040) && (workChar <= 1103)) {
            resultStr.append((char) (workChar-848));
            wasSeparator = false;
          }
          else if(workChar == 92) {
            if(wasSeparator) {
                resultStr.append((char) workChar);
                wasSeparator = false;
            }
            else wasSeparator = true;
          }
          else {
            resultStr.append((char) workChar);
            wasSeparator = false;
          }
        }
        return resultStr.toString();
    }   
}